/*
	mlp_modulesvr.cc

	This C++ file provides a main routin to start an NML server for this application
	It connects to all of the NML channels used by this application.
	If they are all valid it will call run_nml_servers(), otherwise it will exit immediately.

	MODIFICATIONS:
	Thu Dec 21 12:37:03 EST 2000	Created.

*/

// Include Files
#include <stdlib.h> // exit()
#include "rcs.hh" 	// Common RCS definitions
#include "mlp_nnn.hh" 	// mlp_nnFormat

// NML Channel Pointers
static RCS_CMD_CHANNEL *mlp_nn_cmd = NULL;
static RCS_STAT_CHANNEL *mlp_nn_stat = NULL;
static NML *errlog = NULL;

static int InitNML()
{


	// mlp_nn
	mlp_nn_cmd = new RCS_CMD_CHANNEL(mlp_nnFormat, "mlp_nn_cmd", "mlp_modulesvr", "mlp_module.nml");
	if(NULL == mlp_nn_cmd)
		return -1;
	if(!mlp_nn_cmd->valid())
		return -1;

	mlp_nn_stat = new RCS_STAT_CHANNEL(mlp_nnFormat, "mlp_nn_sts", "mlp_modulesvr", "mlp_module.nml");
	if(NULL == mlp_nn_stat)
		return -1;
	if(!mlp_nn_stat->valid())
		return -1;

	errlog = new NML(nmlErrorFormat, "errlog", "mlp_modulesvr", "mlp_module.nml");
	if(NULL == errlog)
		return -1;
	if(!errlog->valid())
		return -1;

	return 0;
}

static void DeleteNML()
{

	// mlp_nn
	if(NULL != mlp_nn_cmd)
	{
		delete mlp_nn_cmd;
		mlp_nn_cmd = NULL;
	}

	if(NULL != mlp_nn_stat)
	{
		delete mlp_nn_stat;
		mlp_nn_stat = NULL;
	}

	if(NULL != errlog)
	{
		delete errlog;
		errlog = NULL;
	}

}

// Main 
#ifdef VXWORKS
extern "C" int mlp_modulesvr_run();

int mlp_modulesvr_run()
#else
int main(int argc, char **argv)
#endif
{

	set_rcs_print_destination(RCS_PRINT_TO_STDOUT);

	if(InitNML() < 0)
	{
		DeleteNML();
		rcs_exit(-1);
	}

	run_nml_servers();

}

